<?php
ini_set("display_errors",1);
error_reporting(E_ALL);
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2012 - 2015 All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);
if (version_compare(PHP_VERSION, '5.3.1', '<'))
{
	die('Your host needs to use PHP 5.3.1 or higher to run this version of Joomla!');
}
define('_JEXEC', 1);
defined( '_JEXEC' ) or die( 'Restricted access' );
define('DS', DIRECTORY_SEPARATOR);
$dirname=str_ireplace(DS.'modules'.DS.'mod_paymybill'.DS.'return','', dirname(__FILE__));
if (file_exists($dirname.DS.'defines.php'))
{
	include_once $dirname.DS.'defines.php';
}
if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.DS.'includes/defines.php';
}
require_once JPATH_BASE.DS.'includes/framework.php';
// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;
// Instantiate the application.
$app = JFactory::getApplication('site');
$lang = JFactory::getLanguage();
$extension = 'mod_paymybill';
$language_tag = $lang->getTag();
$reload = true;
$lang->load($extension, $dirname, $language_tag, $reload);
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."helper.php");
$PMBHelper = new PMBHelper();
$method_name="Romcard";
$id=isset($_GET[ "ORDER" ])?$_GET[ "ORDER" ]+0:0;
if($id==0)
  exit;
$order_id="";
$db=JFactory::getDbo();
$sql="select order_id from #__paymybill where id=".$id;
$db->setQuery($sql);
$res=$db->loadObject();
if(isset($res->order_id) && $res->order_id!="")
{
  $order_id=$res->order_id;
}
else
{
  exit;
}
$module_id=0;
$tarr=explode("-",$order_id);
$module_id=$tarr[1]+0;
if($module_id==0)
  exit;
$order_paid=0;
$params=$PMBHelper->getWorkingModParams($module_id);
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
$pmbf=new PMBFunctions();
$details=$pmbf->getOrderDetails($order_id);
$BT_KEY=$params['romcard_BT_KEY'];
$sData = "";
	
$sTerminal = $_GET[ "TERMINAL" ];
AddField( $sData, $sTerminal );
$sTrType = $_GET[ "TRTYPE" ];
AddField( $sData, $sTrType );
$sOrder = $_GET[ "ORDER" ];
AddField( $sData, $sOrder );
$sAmount = $_GET[ "AMOUNT" ];
AddField( $sData, $sAmount );
$sCurrency = $_GET[ "CURRENCY" ];
AddField( $sData, $sCurrency );
$sDesc = $_GET[ "DESC" ];
AddField( $sData, $sDesc );
$sAction = $_GET[ "ACTION" ];
AddField( $sData, $sAction );
$sRC = $_GET[ "RC" ];
AddField( $sData, $sRC );
$sMessage = $_GET[ "MESSAGE" ];
AddField( $sData, $sMessage );
$sRRN = $_GET[ "RRN" ];
AddField( $sData, $sRRN );
$sIntRef = $_GET[ "INT_REF" ];
AddField( $sData, $sIntRef );
$sApproval = $_GET[ "APPROVAL" ];
AddField( $sData, $sApproval );
$sTimeStamp = $_GET[ "TIMESTAMP" ];
AddField( $sData, $sTimeStamp );
$sNonce = $_GET[ "NONCE" ];
AddField( $sData, $sNonce );
$sSign = $_GET[ "P_SIGN" ];
$sHash = CalculateHash( $sData, $BT_KEY );
if( $sSign != $sHash )
{
	// Date invalide
	die( "Mesaj invalid" );
}
if( $sTrType == 0 )
{
	if( $sAction == 0 )
	{
		$order_paid=1;
  }
}
if($order_paid==1)
{
  //update the record
  $sql="update #__paymybill set
  `TERMINAL`='".$db->escape($sTerminal)."',
  `TRTYPE`='".$db->escape($sTrType)."',
  `ORDER`='".$db->escape($sOrder)."',
  `AMOUNT`='".$db->escape($sAmount)."',
  `DESC`='".$db->escape($sDesc)."',
  `ACTION`='".$db->escape($sAction)."',
  `RC`='".$db->escape($sRC)."',
  `MESSAGE`='".$db->escape($sMessage)."',
  `RRN`='".$db->escape($sRRN)."',
  `INT_REF`='".$db->escape($sIntRef)."',
  `APPROVAL`='".$db->escape($sApproval)."',
  `TIMESTAMP`='".$db->escape($sTimeStamp)."',
  `RRN_Preauth`='".$db->escape($sRRN)."',
  `INT_REF_Preauth`='".$db->escape($sIntRef)."',
  `mdate`='".time()."'
  where id=".$id;
  $db->setQuery($sql);
  $db->query();
  
  $pmbf->setOrderSuccess($params,$details,$method_name);
  //send mail
  if($params['mail_success']!=0)
  {
    $pmbf->sendConfirmationMail('succes',$params,$details,$method_name);
    $pmbf->sendAdminSuccessActionsMail($params,$details);
  }
  $message="";
  $message2="";
  $message='<h1><font color="green"><strong>'.JText::_( 'PMB_MODULE_ORDER_SUCCESS' ).'</strong></font></h1>';
  $message2='alert(\''.str_replace("'","\\'",JText::_( 'PMB_MODULE_ORDER_SUCCESS' )).'\');';
  
}
else
{
  $pmbf->setOrderCancelled($params,$details,$method_name);
  //send mail
  if($params['mail_cancelled']!=0)
  {
    $pmbf->sendConfirmationMail('anulata',$params,$details,$method_name);
  }
  $message="";
  $message2="";
  $message='<h1><font color="red"><strong>'.JText::_( 'PMB_MODULE_ORDER_CANCELED' ).'</strong></font></h1>';
  $message2='alert(\''.str_replace("'","\\'",JText::_( 'PMB_MODULE_ORDER_CANCELED' )).'\');';
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <meta http-equiv="content-type" content="text/html; charset=windows-1250">
  <meta name="generator" content="PSPad editor, www.pspad.com">
  <title></title>
  </head>
  <body>
    <?php echo $message;?>
    <a href="http://<?php echo $_SERVER['HTTP_HOST']?>">Click Here</a> to renturn to our website.
    <script type="text/javascript">
    <?php echo $message2;?>
    window.location='http://<?php echo $_SERVER['HTTP_HOST']?>';
    </script>
  </body>
</html>
<?php
function AddField( &$sData, $sFieldValue )
{
	if( strlen( $sFieldValue ) == 0 )
	{
		$sData .= "-";
	}
	else
	{
		$sData .= strlen( $sFieldValue ) . $sFieldValue;
	}
}
function CalculateHash( $sData, $BT_KEY )
{
	return strtoupper( hash_hmac( "sha1", $sData, pack( 'H*', $BT_KEY ) ) );
}
?>